/***************************************************************************
 * Programa que implementa funcionalidades de administração e consultas a  *
 * um banco de dados de linhas de ônibus, o qual, além das linhas,         *
 * armazena empresas, horários, itinerários e logradouros.                 *
 ***************************************************************************
 * Desenvolvido por Adriano Pereira para a disciplina de Fundamentos de    *
 * Banco de Dados - II Sem 2008 - UFSM - Curso de Ciência da Computação    *
 ***************************************************************************
 * Adriano Pereira
 * 2701049
 * peradri@gmail.com
 */

/* 
 * Consulta.java
 *
 * Created on 6 de Novembro de 2008, 22:31
 * Desenvolvido com auxílio da IDE NetBeans 6.1
 */

/**
 *
 * @author  adriano
 */
 
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;

/**
 Classe que implementa, de forma visual, consultas ao banco de dados.
*/
public class Consulta extends javax.swing.JFrame {

   private AcessaBD db;
   private Logradouro lg;

    /** Creates new form Consulta */
    public Consulta() {
       try{
          db = new AcessaBD();
          lg = new Logradouro(db);
       }catch(Exception e){}
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
        
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        entrada = new javax.swing.JTextField();
        list1 = new java.awt.List();
        linhasEmpresa = new javax.swing.JButton();
        itinerario = new javax.swing.JButton();
        linhasLogradouro = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        quadroHorario = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jLabel1.setText("Entrada de dados");

        entrada.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                entradaActionPerformed(evt);
            }
        });

        linhasEmpresa.setText("Linhas Empresa");
        linhasEmpresa.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                linhasEmpresaActionPerformed(evt);
            }
        });

        itinerario.setText("Itinerário");
        itinerario.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itinerarioActionPerformed(evt);
            }
        });

        linhasLogradouro.setText("Linhas Logradouro");
        linhasLogradouro.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                linhasLogradouroActionPerformed(evt);
            }
        });

        jLabel2.setText("Desenvolvido por Adriano Pereira");

        quadroHorario.setText("Quadro Horário");
        quadroHorario.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                quadroHorarioActionPerformed(evt);
            }
        });


        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(list1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(entrada, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 204, Short.MAX_VALUE)
                        .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING))
                    .addComponent(linhasEmpresa)
                    .addComponent(itinerario)
                    .addComponent(linhasLogradouro)
                    .addComponent(jLabel2)
                    .addComponent(quadroHorario))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(entrada, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(list1, javax.swing.GroupLayout.PREFERRED_SIZE, 170, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(linhasEmpresa)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(itinerario)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(linhasLogradouro)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(quadroHorario)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLabel2)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>

private void entradaActionPerformed(java.awt.event.ActionEvent evt) {                                        
// TODO add your handling code here:
}                                       

/**
   Seleciona as linhas de determinada empresa, basendo-se no nome da empresa
*/
private void linhasEmpresaActionPerformed(java.awt.event.ActionEvent evt) {                                              
   try{
      ResultSet rs = db.query("SELECT Linha.idLinha,Linha.nome FROM Linha,Empresa WHERE Empresa.nomeEmpresa = '"+entrada.getText()+"' AND Linha.idEmpresa = Empresa.idEmpresa");
      try{
         this.inserirLista(rs);
      }catch(SQLException e){
         System.out.println(e);
      }
   }catch(Exception e){}

}                                             

/**
   Seleciona o itinerario de determinada linha, a partir do código dessa linha
*/
private void itinerarioActionPerformed(java.awt.event.ActionEvent evt) {
   try{
      ResultSet rs = db.query("SELECT Logradouro.nomeLogradouro FROM Logradouro,Itinerario WHERE Itinerario.idLinha ="+ Integer.parseInt(entrada.getText()) +"AND Logradouro.idLogradouro = Itinerario.idLogradouro ORDER BY ordem ASC"); // Seleciona o nome dos logradouros cujo itinerário da linha recebida por parâmetro passa.
      try{
         this.inserirLista(rs);
      }catch(SQLException e){
         System.out.println(e);
      }
   }catch(Exception e){}
}

/**
   Seleciona as linhas que passam em determinado logradouro, com base no nome 
   desse logradouro
*/
private void linhasLogradouroActionPerformed(java.awt.event.ActionEvent evt) {
   try{
      ResultSet rs = db.query("SELECT DISTINCT Linha.nome FROM Linha,Itinerario,Logradouro WHERE Logradouro.nomeLogradouro = '"+entrada.getText()+"' AND Itinerario.idLogradouro = Logradouro.idLogradouro and Itinerario.idLinha = Linha.idLinha");
      try{
         this.inserirLista(rs);
      }catch(SQLException e){
         System.out.println(e);
      }
   }catch(Exception e){}
   //System.out.println(entrada.getText());
}

/**
   Obter o quadro de horário de uma determinada linha, dado seu código. 
*/
private void quadroHorarioActionPerformed(java.awt.event.ActionEvent evt) {
   try{
      ResultSet rs = db.query("SELECT Horario.hora FROM Horario WHERE Horario.idLinha ="+ Integer.parseInt(entrada.getText()));
      int i = 0;
//      if (rs.isFirst())
//         System.out.print("AQUUU!");
//      while (rs.next())
//         i++;
//      System.out.println(i);
//      rs.absolute(0);
      try{
         this.inserirLista(rs);
      }catch(SQLException e){
         System.out.println(e);
      }
   }catch(Exception e){
      System.out.println(e);
   }
}

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Consulta().setVisible(true);
            }
        });
    }
    
    private void inserirLista(ResultSet rs) throws SQLException{
       ResultSetMetaData meta = rs.getMetaData();
       int i = 0;
       list1.removeAll();
       while (rs.next()){
          i++;
          String str = "";
          for (int j = 1; j<=meta.getColumnCount(); j++)
             str = str + rs.getObject(j).toString() + " - ";
//          Object obj = rs.getObject(1); // primeira coluna (única)
          list1.add(str);
       }
       // Verifica se algum dado foi inserido. Se nenhum for, abre uma janela indicando 
       // que nada foi encontrado.
       if (i==0)
         openDialog();
    }
    
    // JDialog. Mostra que nenhum dado foi encontrado
    private void openDialog() {  
        dialog = new javax.swing.JDialog();
        javax.swing.JButton botao = new javax.swing.JButton("Nenhum dado encontrado!");  
        botao.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botaoActionPerformed(evt);
            }
        });
        dialog.getContentPane().add(botao);
        dialog.setModal(true);  
        dialog.pack();  
        dialog.setVisible(true);  
    }
    private void botaoActionPerformed(java.awt.event.ActionEvent evt) {
      dialog.setVisible(false);
   }

    // Variables declaration - do not modify
    private javax.swing.JTextField entrada;
    private javax.swing.JButton itinerario;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JButton linhasEmpresa;
    private javax.swing.JButton linhasLogradouro;
    private javax.swing.JButton quadroHorario;
    private java.awt.List list1;
    private javax.swing.JDialog dialog;
    // End of variables declaration

}

