/***************************************************************************
 * Programa que implementa funcionalidades de administração e consultas a  *
 * um banco de dados de linhas de ônibus, o qual, além das linhas,         *
 * armazena empresas, horários, itinerários e logradouros.                 *
 ***************************************************************************
 * Desenvolvido por Adriano Pereira para a disciplina de Fundamentos de    *
 * Banco de Dados - II Sem 2008 - UFSM - Curso de Ciência da Computação    *
 ***************************************************************************
 * Adriano Pereira
 * 2701049
 * peradri@gmail.com
 */
 
import java.sql.SQLException;
import java.sql.ResultSet;

/**
   Classe de tratamento da tabela "Empresa"      
*/
public class Empresa{
   AcessaBD db;
   
   /**
      @param db Objeto da classe AcessaBD
   */
   public Empresa(AcessaBD db){
      this.db = db;
   }
   
   /**
      Lista todas as empresas
   */
   public void listar(){
      try{ 
         ResultSet rs = db.query("SELECT * FROM Empresa");
         db.dump(rs);
      }catch(Exception e){ System.out.println("Nao foi possivel listar as empresas: "+e);}
   }
   
   /**
      Lista determinada empresa
      @param idEmpresa id da empresa a ser listada
   */
   public void listar(int idEmpresa){
      try{ 
         ResultSet rs = db.query("SELECT * FROM Empresa WHERE idEmpresa = "+idEmpresa);
         db.dump(rs);
      }catch(Exception e){ System.out.println("Nao foi possivel listar as empresas: "+e);}
   }
   
   /**
      Insere uma empresa na tabela
   */
   public void inserir(String nome, String telefone, String site, String endereco){
      try{
         db.update("INSERT INTO Empresa (nomeEmpresa, telefone, site, endereco) VALUES ('"+nome+"', '"+telefone+"', '"+site+"', '"+endereco+"')");
      }catch(Exception e){
         System.out.println("Nao foi possivel adicionar uma nova empresa: "+e);
      } 
   }
   
   /**
      Remove uma empresa
   */
   public void remover(int id){
      try{
//         db.update("DELETE FROM Horario WHERE Linha.idEmpresa = "+id+" AND Horario.idLinha= Linha.idLinha");
//         db.update("DELETE FROM Itinerario WHERE Linha.idEmpresa = "+id+" AND Horario.idLinha= Linha.idLinha");
//         db.update("DELETE FROM Linha WHERE idEmpresa = "+id);
         db.update("DELETE FROM Empresa WHERE idEmpresa = "+id);
      }catch(Exception e){
         System.out.println("Nao foi possivel eliminar a empresa "+id+"!");
         System.out.println("Elimine primeiramente as linhas pertencentes a essa empresa! "+e);
      }
   }
   
   /**
      Edita empresa. 
   */
   public void editar(int id, String nome, String telefone, String site, String endereco){
      try{
         if (nome.length() != 0)
            db.update("UPDATE Empresa SET nomeEmpresa = '"+nome+"' WHERE idEmpresa ="+id);
         if (telefone.length() != 0)
            db.update("UPDATE Empresa SET telefone = '"+telefone+"' WHERE idEmpresa ="+id);
         if (site.length() != 0)
            db.update("UPDATE Empresa SET site = '"+site+"' WHERE idEmpresa ="+id);
         if (endereco.length() != 0)
            db.update("UPDATE Empresa SET endereco = '"+endereco+"' WHERE idEmpresa ="+id);
      }catch(Exception e){
         System.out.println("Nao foi possivel editar a empresa: "+e);
      }
   }
   
   /**
      Verifica se a empresa cujo código é passado por referência está no banco.
   */
   public boolean verifica(int idEmpresa){
      ResultSet rs;
      try {
         // Conta o número de ocorrências do idEmpresa (0 ou 1)
         rs = db.query("SELECT COUNT (idEmpresa) FROM Empresa WHERE idEmpresa = "+ idEmpresa);
         rs.next();
         // Empresa existe?
         return (rs.getInt(1) == 1);
      }catch(Exception e){
         return false;
      }
   }
}

