/***************************************************************************
 * Programa que implementa funcionalidades de administração e consultas a  *
 * um banco de dados de linhas de ônibus, o qual, além das linhas,         *
 * armazena empresas, horários, itinerários e logradouros.                 *
 ***************************************************************************
 * Desenvolvido por Adriano Pereira para a disciplina de Fundamentos de    *
 * Banco de Dados - II Sem 2008 - UFSM - Curso de Ciência da Computação    *
 ***************************************************************************
 * Adriano Pereira
 * 2701049
 * peradri@gmail.com
 */

import java.sql.SQLException;
import java.sql.ResultSet;


/**
   Classe de tratamento da tabela "Horario"
*/
public class Horario{
   AcessaBD db;
   
   /**
      @param db Objeto da classe AcessaBD
   */
   public Horario(AcessaBD db){
      this.db = db;
   }
   
   public void listar(){
      try{ 
         ResultSet rs = db.query("SELECT Horario.*,Linha.nome FROM Horario,Linha WHERE Horario.idLinha = Linha.idLinha");
         db.dump(rs);
      }catch(Exception e){ System.out.println("Nao foi possivel listar os horarios: "+e);}
      
   }
   
   /**
      Lista determinado horário
   */
   public void listar(int id){
      try{ 
         ResultSet rs = db.query("SELECT Horario.hora,Horario.idHorario,Linha.nome FROM Horario JOIN Linha ON Horario.idLinha =  Linha.idLinha WHERE idHorario = "+id);
         db.dump(rs);
      }catch(Exception e){ System.out.println("Nao foi possivel listar os horarios: "+e);}
   }
   
   public void inserir(String hora, String min, int idLinha){
      try{
         String horario = hora+":"+min+":00";
         db.update("INSERT INTO Horario (hora, idLinha) VALUES ('"+horario+"', "+idLinha+")");
      }catch(SQLException e){
         System.out.println("Nao foi possivel inserir o horario! "+e);
      } 
   }
   
   public void remover(int id){
      try{
         db.update("DELETE FROM Horario WHERE idHorario = "+id);
      }catch(Exception e){
         System.out.println("Nao foi possivel eliminar o horario "+id+": "+e);
      }
   }
   
   /**
      Edita um horário, se for passado alguma hora como parâmetro
   */
   public void editar(int id, String hora, String min){
      try{
         if (hora.length() != 0){
            String horario = hora+":"+min+":00";
            db.update("UPDATE Horario SET hora = '"+horario+"' WHERE idHorario ="+id);
         }
      }catch(Exception e){
         System.out.println("Nao foi possivel editar o horario: "+e);
      }
   }
   
   /**
      Verifica se o horário cujo código é passado por referência está no banco.
   */
   public boolean verifica(int idHorario){
      ResultSet rs;
      try {
         // Conta o número de ocorrências do idHorario (0 ou 1)
         rs = db.query("SELECT COUNT (idHorario) FROM Horario WHERE idHorario = "+ idHorario);
         rs.next();
         // Horário existe?
         return (rs.getInt(1) == 1);
      }catch(Exception e){
         return false;
      }
   }
}

