/***************************************************************************
 * Programa que implementa funcionalidades de administração e consultas a  *
 * um banco de dados de linhas de ônibus, o qual, além das linhas,         *
 * armazena empresas, horários, itinerários e logradouros.                 *
 ***************************************************************************
 * Desenvolvido por Adriano Pereira para a disciplina de Fundamentos de    *
 * Banco de Dados - II Sem 2008 - UFSM - Curso de Ciência da Computação    *
 ***************************************************************************
 * Adriano Pereira
 * 2701049
 * peradri@gmail.com
 */

import java.sql.SQLException;
import java.sql.ResultSet;

/**
   Classe de tratamento da tabela Itinerario
*/

public class Itinerario{
   AcessaBD db;
   
   public Itinerario(AcessaBD db){
      this.db = db;
   }
   
   public void listar(){
      try{ 
         ResultSet rs = db.query("SELECT Itinerario.idLinha,Linha.nome,Itinerario.idLogradouro,Logradouro.nomeLogradouro,Itinerario.ordem FROM Itinerario,Linha,Logradouro WHERE Itinerario.idLinha = Linha.idLinha AND Itinerario.idLogradouro = Logradouro.idLogradouro");
         db.dump(rs);
      }catch(Exception e){ System.out.println("Nao foi possivel listar os itinerarios: "+e);}
   }
   
   public void listar(int idLinha, int ordem){
      try{ 
         ResultSet rs = db.query("SELECT Linha.nome,Logradouro.nomeLogradouro,Itinerario.ordem FROM Itinerario JOIN Linha ON Itinerario.idLinha = Linha.idLinha JOIN Logradouro ON Itinerario.idLogradouro = Logradouro.idLogradouro WHERE idLinha = "+idLinha+" AND ordem = "+ordem);
         db.dump(rs);
      }catch(Exception e){ System.out.println("Nao foi possivel listar os itinerarios: "+e);}
   }
   
   public void inserir(int idLinha, int idLogradouro, int ordem){
      try{
         db.update("INSERT INTO Itinerario (idLinha, idLogradouro, ordem) VALUES ('"+idLinha+"', "+idLogradouro+", "+ordem+")");
      }catch(SQLException e){
         System.out.println("Nao foi possivel inserir o itinerario! "+e);
      } 
   }
   
   public void remover(int idLinha, int ordem){
      try{
         db.update("DELETE FROM Itinerario WHERE idLinha = "+idLinha+" AND ordem = "+ordem);
      }catch(Exception e){
         System.out.println("Nao foi possivel eliminar o itinerario "+idLinha+": "+e);
      }
   }
   
   public void editar(int idLinha, int idLogradouro, int ordem){
      try{
         db.update("UPDATE Itinerario SET ordem = '"+ordem+"' WHERE idlinha ="+idLinha+" AND idLogradouro = "+idLogradouro);
      }catch(Exception e){
         System.out.println("Nao foi possivel editar o itinerario: "+e);
      }
   }
   
   /**
      Verifica se a linha cujo código é passado por referência está no banco.
   */
   public boolean verifica(int idLinha, int ordem){
      ResultSet rs;
      try {
         // Conta o número de ocorrências do idLinha (0 ou 1)
         rs = db.query("SELECT COUNT (idLinha) FROM Itinerario WHERE idLinha = "+ idLinha + "AND ordem = "+ordem);
         rs.next();
         // Itinerário existe?
         return (rs.getInt(1) == 1);
      }catch(Exception e){
         return false;
      }
   }

}
