/***************************************************************************
 * Programa que implementa funcionalidades de administração e consultas a  *
 * um banco de dados de linhas de ônibus, o qual, além das linhas,         *
 * armazena empresas, horários, itinerários e logradouros.                 *
 ***************************************************************************
 * Desenvolvido por Adriano Pereira para a disciplina de Fundamentos de    *
 * Banco de Dados - II Sem 2008 - UFSM - Curso de Ciência da Computação    *
 ***************************************************************************
 * Adriano Pereira
 * 2701049
 * peradri@gmail.com
 */

import java.sql.SQLException;
import java.sql.ResultSet;

/**
   Classe de tratamento da tabela Linha
*/

public class Linha{
   AcessaBD db;
   
   public Linha(AcessaBD db){
      this.db = db;
   }
   
   public void listar(){
      try{ 
         ResultSet rs = db.query("SELECT Linha.*,Empresa.nomeEmpresa FROM Linha,Empresa WHERE Linha.idEmpresa = Empresa.idEmpresa");
         db.dump(rs);
      }catch(Exception e){ System.out.println("Nao foi possivel listar as linhas: "+e);}
   }
   
   public void listar(int id){
      try{ 
         ResultSet rs = db.query("SELECT * FROM Linha WHERE idLinha = "+id);
         db.dump(rs);
      }catch(Exception e){ System.out.println("Nao foi possivel listar as linhas: "+e);}
   }
   
   public void inserir(String nome, int idEmpresa){
      try{
         db.update("INSERT INTO Linha (nome, idEmpresa) VALUES ('"+nome+"', "+idEmpresa+")");
      }catch(SQLException e){
         System.out.println("Empresa nao encontrada! "+e);
      } 
   }
   
/*   public void remover_por_empresa(int idEmpresa){
      try{
         db.update("DELETE FROM Horario WHERE Linha.idEmpresa = "+idEmpresa+" AND Horario.idLinha= Linha.idLinha");
         db.update("DELETE FROM Itinerario WHERE Linha.idEmpresa = "+idEmpresa+" AND Horario.idLinha= Linha.idLinha);
         db.update("DELETE FROM Linha WHERE idEmpresa = "+idEmpresa);
      }catch(Exception e){
         System.out.println("Nao foi possivel eliminar a linha "+id+": "+e);
      }
   }
*/   

   /**
      Apaga os horários, itinerários e a linha
   */
   public void remover(int id){
      try{
         db.update("DELETE FROM Horario WHERE idLinha="+id);
         db.update("DELETE FROM Itinerario WHERE idLinha="+id);
         db.update("DELETE FROM Linha WHERE idLinha = "+id);
      }catch(Exception e){
         System.out.println("Nao foi possivel eliminar a linha "+id+": "+e);
      }
   }
   
   public void editar(int id, String nome, int idEmpresa){
      try{
         if (nome.length() != 0)
            db.update("UPDATE Linha SET nome = '"+nome+"' WHERE idLinha ="+id);
         if (idEmpresa!=-1)
            db.update("UPDATE Linha SET idEmpresa = "+idEmpresa+" WHERE idLinha ="+id);
      }catch(Exception e){
         System.out.println("Nao foi possivel editar a linha: "+e);
      }
   }
   
   /**
      Verifica se a linha cujo código é passado por referência está no banco.
   */
   public boolean verifica(int idLinha){
      ResultSet rs;
      try {
         // Conta o número de ocorrências do idLinha (0 ou 1)
         rs = db.query("SELECT COUNT (idLinha) FROM Linha WHERE idLinha = "+ idLinha);
         rs.next();
         // Linha existe?
         return (rs.getInt(1) == 1);
      }catch(Exception e){
         return false;
      }
   }
   
}

