/***************************************************************************
 * Programa que implementa funcionalidades de administração e consultas a  *
 * um banco de dados de linhas de ônibus, o qual, além das linhas,         *
 * armazena empresas, horários, itinerários e logradouros.                 *
 ***************************************************************************
 * Desenvolvido por Adriano Pereira para a disciplina de Fundamentos de    *
 * Banco de Dados - II Sem 2008 - UFSM - Curso de Ciência da Computação    *
 ***************************************************************************
 * Adriano Pereira
 * 2701049
 * peradri@gmail.com
 */

import java.sql.SQLException;
import java.sql.ResultSet;

/**
   Classe de tratamento da tabela Logradouro
*/

public class Logradouro{
   AcessaBD db;
   
   public Logradouro(AcessaBD db){
      this.db = db;
   }
   
   public void listar(){
      try{ 
         ResultSet rs = db.query("SELECT * FROM Logradouro");
         db.dump(rs);
      }catch(Exception e){ System.out.println("Nao foi possivel listar os logradouros: "+e);}
   }
   
   public void listar(int idLogradouro){
      try{ 
         ResultSet rs = db.query("SELECT * FROM Logradouro WHERE idLogradouro="+idLogradouro);
         db.dump(rs);
      }catch(Exception e){ System.out.println("Nao foi possivel listar os logradouros: "+e);}
   }
   
   public void inserir(String nome){
      try{
         db.update("INSERT INTO Logradouro (nomeLogradouro) VALUES ('"+nome+"')");
      }catch(SQLException e){
         System.out.println("Nao foi possivel inserir o logradouro! "+e);
      } 
   }
   
   /**
      Remove o logradouro. Deve-se remover primeiramente os itinerários
      que passam pelo logradouro antes de removê-lo.
   */
   public void remover(int id){
      try{
         db.update("DELETE FROM Logradouro WHERE idLogradouro = "+id);
      }catch(Exception e){
         System.out.println("Nao foi possivel eliminar o logradouro "+id+": "+e);
      }
   }
   
   public void editar(int id, String nome){
      try{
         if (nome.length() != 0)
            db.update("UPDATE Logradouro SET nomeLogradouro = '"+nome+"' WHERE idLogradouro ="+id);
      }catch(Exception e){
         System.out.println("Nao foi possivel editar o logradouro: "+e);
      }
   }
   
   /**
      Verifica se o logradouro cujo código é passado por referência está no banco.
   */
   public boolean verifica(int idLogradouro){
      ResultSet rs;
      try {
         // Conta o número de ocorrências do idLogradouro (0 ou 1)
         rs = db.query("SELECT COUNT (idLogradouro) FROM Logradouro WHERE idLogradouro = "+ idLogradouro);
         rs.next();
         // Logradouro existe?
         return (rs.getInt(1) == 1);
      }catch(Exception e){
         return false;
      }
   }
}

